// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from plotjuggler_msgs:msg/Dictionary.idl
// generated code does not contain a copyright notice
#include "plotjuggler_msgs/msg/detail/dictionary__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `names`
#include "rosidl_runtime_c/string_functions.h"

bool
plotjuggler_msgs__msg__Dictionary__init(plotjuggler_msgs__msg__Dictionary * msg)
{
  if (!msg) {
    return false;
  }
  // dictionary_uuid
  // names
  if (!rosidl_runtime_c__String__Sequence__init(&msg->names, 0)) {
    plotjuggler_msgs__msg__Dictionary__fini(msg);
    return false;
  }
  return true;
}

void
plotjuggler_msgs__msg__Dictionary__fini(plotjuggler_msgs__msg__Dictionary * msg)
{
  if (!msg) {
    return;
  }
  // dictionary_uuid
  // names
  rosidl_runtime_c__String__Sequence__fini(&msg->names);
}

bool
plotjuggler_msgs__msg__Dictionary__are_equal(const plotjuggler_msgs__msg__Dictionary * lhs, const plotjuggler_msgs__msg__Dictionary * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // dictionary_uuid
  if (lhs->dictionary_uuid != rhs->dictionary_uuid) {
    return false;
  }
  // names
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->names), &(rhs->names)))
  {
    return false;
  }
  return true;
}

bool
plotjuggler_msgs__msg__Dictionary__copy(
  const plotjuggler_msgs__msg__Dictionary * input,
  plotjuggler_msgs__msg__Dictionary * output)
{
  if (!input || !output) {
    return false;
  }
  // dictionary_uuid
  output->dictionary_uuid = input->dictionary_uuid;
  // names
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->names), &(output->names)))
  {
    return false;
  }
  return true;
}

plotjuggler_msgs__msg__Dictionary *
plotjuggler_msgs__msg__Dictionary__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  plotjuggler_msgs__msg__Dictionary * msg = (plotjuggler_msgs__msg__Dictionary *)allocator.allocate(sizeof(plotjuggler_msgs__msg__Dictionary), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plotjuggler_msgs__msg__Dictionary));
  bool success = plotjuggler_msgs__msg__Dictionary__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
plotjuggler_msgs__msg__Dictionary__destroy(plotjuggler_msgs__msg__Dictionary * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    plotjuggler_msgs__msg__Dictionary__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
plotjuggler_msgs__msg__Dictionary__Sequence__init(plotjuggler_msgs__msg__Dictionary__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  plotjuggler_msgs__msg__Dictionary * data = NULL;

  if (size) {
    data = (plotjuggler_msgs__msg__Dictionary *)allocator.zero_allocate(size, sizeof(plotjuggler_msgs__msg__Dictionary), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plotjuggler_msgs__msg__Dictionary__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plotjuggler_msgs__msg__Dictionary__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plotjuggler_msgs__msg__Dictionary__Sequence__fini(plotjuggler_msgs__msg__Dictionary__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plotjuggler_msgs__msg__Dictionary__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plotjuggler_msgs__msg__Dictionary__Sequence *
plotjuggler_msgs__msg__Dictionary__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  plotjuggler_msgs__msg__Dictionary__Sequence * array = (plotjuggler_msgs__msg__Dictionary__Sequence *)allocator.allocate(sizeof(plotjuggler_msgs__msg__Dictionary__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = plotjuggler_msgs__msg__Dictionary__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
plotjuggler_msgs__msg__Dictionary__Sequence__destroy(plotjuggler_msgs__msg__Dictionary__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    plotjuggler_msgs__msg__Dictionary__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
plotjuggler_msgs__msg__Dictionary__Sequence__are_equal(const plotjuggler_msgs__msg__Dictionary__Sequence * lhs, const plotjuggler_msgs__msg__Dictionary__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!plotjuggler_msgs__msg__Dictionary__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
plotjuggler_msgs__msg__Dictionary__Sequence__copy(
  const plotjuggler_msgs__msg__Dictionary__Sequence * input,
  plotjuggler_msgs__msg__Dictionary__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(plotjuggler_msgs__msg__Dictionary);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    plotjuggler_msgs__msg__Dictionary * data =
      (plotjuggler_msgs__msg__Dictionary *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!plotjuggler_msgs__msg__Dictionary__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          plotjuggler_msgs__msg__Dictionary__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!plotjuggler_msgs__msg__Dictionary__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
