// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from plotjuggler_msgs:msg/Dictionary.idl
// generated code does not contain a copyright notice
#include "plotjuggler_msgs/msg/detail/dictionary__rosidl_typesupport_fastrtps_cpp.hpp"
#include "plotjuggler_msgs/msg/detail/dictionary__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace plotjuggler_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_plotjuggler_msgs
cdr_serialize(
  const plotjuggler_msgs::msg::Dictionary & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: dictionary_uuid
  cdr << ros_message.dictionary_uuid;
  // Member: names
  {
    cdr << ros_message.names;
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_plotjuggler_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  plotjuggler_msgs::msg::Dictionary & ros_message)
{
  // Member: dictionary_uuid
  cdr >> ros_message.dictionary_uuid;

  // Member: names
  {
    cdr >> ros_message.names;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_plotjuggler_msgs
get_serialized_size(
  const plotjuggler_msgs::msg::Dictionary & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: dictionary_uuid
  {
    size_t item_size = sizeof(ros_message.dictionary_uuid);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: names
  {
    size_t array_size = ros_message.names.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (ros_message.names[index].size() + 1);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_plotjuggler_msgs
max_serialized_size_Dictionary(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: dictionary_uuid
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: names
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  return current_alignment - initial_alignment;
}

static bool _Dictionary__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const plotjuggler_msgs::msg::Dictionary *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _Dictionary__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<plotjuggler_msgs::msg::Dictionary *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _Dictionary__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const plotjuggler_msgs::msg::Dictionary *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _Dictionary__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_Dictionary(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _Dictionary__callbacks = {
  "plotjuggler_msgs::msg",
  "Dictionary",
  _Dictionary__cdr_serialize,
  _Dictionary__cdr_deserialize,
  _Dictionary__get_serialized_size,
  _Dictionary__max_serialized_size
};

static rosidl_message_type_support_t _Dictionary__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_Dictionary__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace plotjuggler_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_plotjuggler_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<plotjuggler_msgs::msg::Dictionary>()
{
  return &plotjuggler_msgs::msg::typesupport_fastrtps_cpp::_Dictionary__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, plotjuggler_msgs, msg, Dictionary)() {
  return &plotjuggler_msgs::msg::typesupport_fastrtps_cpp::_Dictionary__handle;
}

#ifdef __cplusplus
}
#endif
